/*
 * Main:
 * Calls two tasks.
 *
 * Printer:
 * Events on data on a streaming channel.
 * Prints this data.
 *
 * App:
 * Declares and initializes a structure.
 * Passes address of this structure to ASM.
 *
 * ASM:
 * Takes in the pointer to structure.
 * Sets the Data pointer to this structure.
 * Gets each member of this structure.
 * Adds one to it.
 * Stores it back to data.
 * Passes this result to the printer task over a streaming channel.
 *
 * Spot a mistake!
 */
#include <print.h>
#include <platform.h>
#include <xs1.h>
/*============================================================================*/
typedef struct struct_internal_t
{
  unsigned m0;
  unsigned m1;
  unsigned m2;
  unsigned m3;
  unsigned m4;
  unsigned m5;
}struct_internal_t;

struct_internal_t s;

/*============================================================================*/
extern void asm_dp(struct_internal_t &structure, streaming chanend c_printer);

/*============================================================================*/
void app(streaming chanend c_printer)
{  
  s.m0 = 11; s.m1 = 12; s.m2 = 13; s.m3 = 14; s.m4 = 15; s.m5 = 99;
  asm_dp(s, c_printer);
}
/*============================================================================*/
void printer(streaming chanend c_printer)
{
  unsigned data;
  while(1)
  {
    select
    {
      case c_printer :> data:
      {
        printintln(data);
        break;
      }
    }
  }
}
/*============================================================================*/
int main()
{
  streaming chan c_printer;
  par
  {
    app(c_printer);
    printer(c_printer);
  }
  return 0;
}
/*============================================================================*/
