#include <xs1.h>
#include <platform.h>
#include <print.h>
#include <timer.h>

#define PULSES 100000

on tile[0]: out port p_tx = XS1_PORT_1L;
on tile[0]: clock clk = XS1_CLKBLK_1;

on tile[1]: in port p_rx = XS1_PORT_1L;

extern void asm_event_port_clocked_rx(in port rx, chanend c_printer, unsigned loop);
extern void asm_event_port_clocked_tx(out port tx, unsigned loop);

/*============================================================================*/
void tx()
{
  p_tx <: 0;
  delay_seconds(1);

  stop_clock(clk);
  configure_clock_ref(clk, 50);
  configure_out_port(p_tx, clk, 0);
  start_clock(clk);

  asm_event_port_clocked_tx(p_tx, PULSES);
}
/*============================================================================*/
void printer(chanend c_printer)
{
  unsigned data, done = 0, counter = 0;
  while(!done)
  {
    select
    {
      case c_printer :> data:
      {
        if(data == 0) done = 1;
        else counter++;
        break;
      }
    }
  }
  printstr("Number of pulses = "); printintln(counter);
}
/*============================================================================*/
int main()
{
  chan c_printer;
  par
  {
    on tile[0]: tx();
    on tile[1]: asm_event_port_clocked_rx(p_rx, c_printer, PULSES);
    on tile[1]: printer(c_printer);
  }
  return 0;
}
/*============================================================================*/
